defmodule DecentralisedBookIndex.Sync.BookSync do
  alias DecentralisedBookIndex.Metadata
  alias DecentralisedBookIndex.Metadata.Book

  def create_update(attrs, server_id) do
    case Metadata.get_book_by_id(attrs.id) do
      {:ok, book} ->
        attrs =
          attrs
          |> Map.delete(:id)
          |> Map.delete(:book_editions_registry)
          |> Map.put(:dbi_server_id, server_id)

        book
        |> Ash.Changeset.for_update(:sync, attrs)
        |> Ash.update!()

        :ok
      {:error, %Ash.Error.Query.NotFound{}} ->
        attrs =
          attrs
          |> Map.put(:dbi_server_id, server_id)

        Book
        |> Ash.Changeset.for_create(:sync_create, attrs)
        |> Ash.create!()

        :ok
    end
  end
end
