defmodule DecentralisedBookIndex.Sync.SyncServerTaskTest do
  use DecentralisedBookIndex.DataCase

  alias DecentralisedBookIndex.Sync.SyncServerTask

  alias DecentralisedBookIndex.Sync.ApiClients.FetchJson
  alias DecentralisedBookIndex.Sync.AuthorSync

  alias DecentralisedBookIndex.Metadata

  alias DecentralisedBookIndex.TestEndpoints
  @test_server_endpoint TestEndpoints.test_api_endpoint()

  describe "sync all" do
    test "servers" do
      server = generate(dbi_server(url: @test_server_endpoint))
      {:ok, author} = Metadata.create_author("Author", "An description")

      assert server = SyncServerTask.sync_all()
    end
  end

  describe "sync one" do
    test "server" do
      server = generate(dbi_server(url: @test_server_endpoint))
      {:ok, author} = Metadata.create_author("Author", "An description")

      assert server = SyncServerTask.sync_one(server)
    end
  end
end
